package pl.asie.foamfix.coremod;

import net.minecraft.block.state.IBlockState;
import net.minecraft.profiler.Profiler;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.math.BlockPos;
import net.minecraft.util.math.MathHelper;
import net.minecraft.world.EnumSkyBlock;
import net.minecraft.world.World;
import net.minecraft.world.WorldProvider;
import net.minecraft.world.chunk.IChunkProvider;
import net.minecraft.world.storage.ISaveHandler;
import net.minecraft.world.storage.WorldInfo;

public class WorldLightingPatch extends World {
	int[] lightUpdateBlockList;

	protected WorldLightingPatch(ISaveHandler saveHandlerIn, WorldInfo info, WorldProvider providerIn, Profiler profilerIn, boolean client) {
		super(saveHandlerIn, info, providerIn, profilerIn, client);
	}

	// TODO: Actually optimize (for now, we just mutablify some BlockPos objects)
	@Override
	public boolean func_180500_c(EnumSkyBlock lightType, BlockPos pos) {
		if (!this.func_175648_a(pos, 17, false)) {
			return false;
		} else {
			int checkedPosition = 0;
			int toCheckCount = 0;
			this.field_72984_F.func_76320_a("getBrightness");
			int currLight = this.func_175642_b(lightType, pos);
			int newLight = this.func_175638_a(pos, lightType);
			int posX = pos.func_177958_n();
			int posY = pos.func_177956_o();
			int posZ = pos.func_177952_p();

			BlockPos.PooledMutableBlockPos checkedPos = BlockPos.PooledMutableBlockPos.func_185346_s();

			if (newLight > currLight) {
				this.lightUpdateBlockList[toCheckCount++] = 133152;
			} else if (newLight < currLight) {
				this.lightUpdateBlockList[toCheckCount++] = 133152 | currLight << 18;

				while (checkedPosition < toCheckCount) {
					int checkedEntry = this.lightUpdateBlockList[checkedPosition++];
					int checkedX = (checkedEntry & 63) - 32 + posX;
					int checkedY = (checkedEntry >> 6 & 63) - 32 + posY;
					int checkedZ = (checkedEntry >> 12 & 63) - 32 + posZ;
					checkedPos.func_181079_c(checkedX, checkedY, checkedZ);

					int checkedNewLight = checkedEntry >> 18 & 15;
					int checkedCurrLight = this.func_175642_b(lightType, checkedPos);

					if (checkedCurrLight == checkedNewLight) {
						this.func_175653_a(lightType, checkedPos, 0);

						if (checkedNewLight > 0) {
							int distX = MathHelper.func_76130_a(checkedX - posX);
							int distY = MathHelper.func_76130_a(checkedY - posY);
							int distZ = MathHelper.func_76130_a(checkedZ - posZ);
							boolean hasSpace = toCheckCount < this.lightUpdateBlockList.length - 6;

							if (distX + distY + distZ < 17 && hasSpace) {
								BlockPos.PooledMutableBlockPos neighborPos = BlockPos.PooledMutableBlockPos.func_185346_s();

								for (EnumFacing enumfacing : EnumFacing.field_82609_l) {
									int neighborX = checkedX + enumfacing.func_82601_c();
									int neighborY = checkedY + enumfacing.func_96559_d();
									int neighborZ = checkedZ + enumfacing.func_82599_e();
									neighborPos.func_181079_c(neighborX, neighborY, neighborZ);
									IBlockState neighborState = this.func_180495_p(neighborPos);

									int l4 = Math.max(1, neighborState.func_177230_c().getLightOpacity(neighborState, this, neighborPos));
									checkedCurrLight = this.func_175642_b(lightType, neighborPos);

									if (checkedCurrLight == checkedNewLight - l4) {
										this.lightUpdateBlockList[toCheckCount++] = neighborX - posX + 32 | neighborY - posY + 32 << 6 | neighborZ - posZ + 32 << 12 | checkedNewLight - l4 << 18;
									}
								}

								neighborPos.func_185344_t();
							}
						}
					}
				}

				checkedPosition = 0;
			}

			this.field_72984_F.func_76319_b();
			this.field_72984_F.func_76320_a("checkedPosition < toCheckCount");

			while (checkedPosition < toCheckCount) {
				int checkedEntry = this.lightUpdateBlockList[checkedPosition++];
				int checkedX = (checkedEntry & 63) - 32 + posX;
				int checkedY = (checkedEntry >> 6 & 63) - 32 + posY;
				int checkedZ = (checkedEntry >> 12 & 63) - 32 + posZ;
				checkedPos.func_181079_c(checkedX, checkedY, checkedZ);

				int checkedNewLight = this.func_175638_a(checkedPos, lightType);
				int checkedCurrLight = this.func_175642_b(lightType, checkedPos);

				if (checkedNewLight != checkedCurrLight) {
					this.func_175653_a(lightType, checkedPos, checkedNewLight);

					if (checkedNewLight > checkedCurrLight) {
						int distX = Math.abs(checkedX - posX);
						int distY = Math.abs(checkedY - posY);
						int distZ = Math.abs(checkedZ - posZ);
						boolean hasSpace = toCheckCount < this.lightUpdateBlockList.length - 6;

						if (distX + distY + distZ < 17 && hasSpace) {
							if (this.func_175642_b(lightType, checkedPos.func_181079_c(checkedX - 1, checkedY, checkedZ)) < checkedNewLight) {
								this.lightUpdateBlockList[toCheckCount++] = checkedX - 1 - posX + 32 + (checkedY - posY + 32 << 6) + (checkedZ - posZ + 32 << 12);
							}

							if (this.func_175642_b(lightType, checkedPos.func_181079_c(checkedX + 1, checkedY, checkedZ)) < checkedNewLight) {
								this.lightUpdateBlockList[toCheckCount++] = checkedX + 1 - posX + 32 + (checkedY - posY + 32 << 6) + (checkedZ - posZ + 32 << 12);
							}

							if (this.func_175642_b(lightType, checkedPos.func_181079_c(checkedX, checkedY - 1, checkedZ)) < checkedNewLight) {
								this.lightUpdateBlockList[toCheckCount++] = checkedX - posX + 32 + (checkedY - 1 - posY + 32 << 6) + (checkedZ - posZ + 32 << 12);
							}

							if (this.func_175642_b(lightType, checkedPos.func_181079_c(checkedX, checkedY + 1, checkedZ)) < checkedNewLight) {
								this.lightUpdateBlockList[toCheckCount++] = checkedX - posX + 32 + (checkedY + 1 - posY + 32 << 6) + (checkedZ - posZ + 32 << 12);
							}

							if (this.func_175642_b(lightType, checkedPos.func_181079_c(checkedX, checkedY, checkedZ - 1)) < checkedNewLight) {
								this.lightUpdateBlockList[toCheckCount++] = checkedX - posX + 32 + (checkedY - posY + 32 << 6) + (checkedZ - 1 - posZ + 32 << 12);
							}

							if (this.func_175642_b(lightType, checkedPos.func_181079_c(checkedX, checkedY, checkedZ + 1)) < checkedNewLight) {
								this.lightUpdateBlockList[toCheckCount++] = checkedX - posX + 32 + (checkedY - posY + 32 << 6) + (checkedZ + 1 - posZ + 32 << 12);
							}
						}
					}
				}
			}

			checkedPos.func_185344_t();

			this.field_72984_F.func_76319_b();
			return true;
		}
	}

	@Override
	protected IChunkProvider func_72970_h() {
		return null;
	}

	@Override
	protected boolean func_175680_a(int x, int z, boolean allowEmpty) {
		return false;
	}
}
